/*  setplotcolor.cpp - 
    This file is part of Kalamaris
    Copyright (C) 2000  Antonio Larrosa Jimenez
    Kalamaris' homepage : http://www.arrakis.es/~rlarrosa/kalamaris.html

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

    Send comments and bug fixes to Antonio Larrosa <larrosa@kde.org>

 ***************************************************************************/
#include "setplotcolor.h"
#include "../constant.h"
#include "../parameter.h"
#include "../color.h"
#include "../qtai/qtai_plot.h"
#include "graphs.h"
#include <kdebug.h>

setPlotColor::setPlotColor() : MapVariableArgumentsInternal(QString::null,"setPlotColor",false)
{ 
  m_parameters[0]=new Parameter("graph");
  m_parameters[0]->setDataType("Constant");
  m_parameters[1]=new Parameter("plot");
  m_parameters[1]->setDataType("Constant");
  m_parameters[2]=new Parameter("color");
  m_parameters[2]->setDataType("Color");
}

setPlotColor::setPlotColor(const setPlotColor &m) : MapVariableArgumentsInternal( m )
{
}
  
Map *setPlotColor::copy(void) const
{
  return new setPlotColor(*this);
}

Map *setPlotColor::eval(const QDict <Map> &vars)
{
  QDict <Map> *vars2=evalParams(vars);
  if (!checkParamTypes(*vars2)) return 0L;
  int id=*vars2->find("$0")->t();
  int trace=*vars2->find("$1")->t();
  Color *color=(Color *)vars2->find("$2");

  AIPlot *plot=Graphs::plot2D(id);
  if (!plot) kdDebug() << "ERROR !" << endl;

  plot->setPlotColor(trace,color->color());

  delete vars2;
  return copy();
  
}

QString setPlotColor::string(void) const
{
  return QString("setPlotColor");
}
