/*  kgl3dwidget.cpp - 
    This file is part of KGL
    Copyright (C) 2000  Antonio Larrosa Jimenez
    KGL' homepage : http://www.arrakis.es/~rlarrosa/kgl.html

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

    Send comments and bug fixes to Antonio Larrosa <larrosa@kde.org>

 ***************************************************************************/
#include "kgl3dwidget.h" 
#include "kgluniverse.h"
#include "kgldataanimate.h"
#include "kglcontrol.h"
#include <kdebug.h>
#include <qscrollbar.h>
#include <qslider.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qvbox.h>
#include <qhbox.h>
#include <qtooltip.h>
#include <math.h>

KGL3DWidget::KGL3DWidget(QWidget *parent, const char *name) : QHBox( parent, name)
{
  m_universe=0L;
}

KGL3DWidget::~KGL3DWidget()
{
  kdDebug() << "KGL3DWidget :: Destructor" << endl;
  delete m_universe;
}

void KGL3DWidget::setUniverse(KGLUniverse *universe)
{
  if (universe)
  {
    m_universe=universe;
    //    m_universe->reparent(this,QPoint (0,0));
  }
  //   else m_universe=new KGLUniverse(this,"universe");
  else 
  {
    //     m_universe=new KGLUniverse(this,"universe");
    m_universe=new KGLDataAnimate(this, "universe");
    kdDebug() << "aa" << endl;
    double x[50];
    double y[50];
    double z[50];
    for (int i=0;i<50;i++) 
    {
      x[i]=0.0;
      y[i]=cos(2*M_PI*i/50.0);
      z[i]=sin(2*M_PI*i/50.0);
    }
    kdDebug() << "b" << endl;
    ((KGLDataAnimate *)m_universe)->setData(x,y,z,50);
    kdDebug() << "c" << endl;
  }

  KGLControls *control=new KGLControls(this,"universeControl");
  kdDebug() << "aaa" << endl;
  control->plug(m_universe);
  kdDebug() << "aaa2" << endl;


  m_universe->moveViewPoint(4.2,1.6,1.1);
//  m_universe->moveViewPoint(1,0,0);
  m_universe->lookTo(0,0,0);
  kdDebug() << "aaa3" << endl;

}

void KGL3DWidget::closeEvent(QCloseEvent *e)
{
  e->accept();
  emit closing(this);
  if (parent() == 0L) delete this;
}                                                                                                                                            
