/*  kglsphere.cpp - 
    This file is part of KGL
    Copyright (C) 2000  Antonio Larrosa Jimenez
    KGL' homepage : http://www.arrakis.es/~rlarrosa/kgl.html

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

    Send comments and bug fixes to Antonio Larrosa <larrosa@kde.org>

 ***************************************************************************/
#include "kglsphere.h"
#include <qgl.h>
#include <kdebug.h>


KGLSphere::KGLSphere(GLfloat x, GLfloat y, GLfloat z, GLfloat r, int slices, QImage texture) : KGLObject(x,y,z)
{
  m_list = glGenLists(1);
  glNewList(m_list, GL_COMPILE);
  GLUquadricObj* q = gluNewQuadric();
  gluQuadricDrawStyle( q, (GLenum) GLU_FILL );
  gluQuadricNormals( q, (GLenum) GLU_SMOOTH );

  if (!texture.isNull()) 
  {
    gluQuadricTexture(q, GL_TRUE);
    texture = texture.convertDepth( 32 ).mirror().swapRGB(); 
    glTexImage2D( GL_TEXTURE_2D, 0, 3, texture.width(), texture.height(), 0,
	GL_RGBA, GL_UNSIGNED_BYTE, texture.bits() );
  }
/*  else 
  {
    glMaterialfv( GL_FRONT, GL_AMBIENT_AND_DIFFUSE, color() );
  }
  */
  gluQuadricNormals(q, GL_SMOOTH);
  gluSphere(q, r, slices, slices);

  glEndList();

  gluDeleteQuadric(q);

}

